function trans()
  require "import"
  import "android.net.Uri"
  import "android.text.Html"
  import "com.androlua.Http"
  import "java.util.Locale"
  import "android.os.Handler"
  import "android.os.Looper"
  import "android.os.Vibrator"

  local luajava = require("luajava")
  local SpeechRecognizer = luajava.bindClass("android.speech.SpeechRecognizer")
  local Intent = luajava.bindClass("android.content.Intent")
  local RecognizerIntent = luajava.bindClass("android.speech.RecognizerIntent")
  local activity = this
  local handler = Handler(Looper.getMainLooper())
  local listening = true

  local vibrator = activity.getSystemService("vibrator")

  -- تهيئة مسبقة للمحرك خارج الدالة
  local recognizer = SpeechRecognizer.createSpeechRecognizer(activity)

  local function startVoiceRecognition(activity)
    local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ar-SA")

    handler.postDelayed(function()
        vibrator.vibrate(50)
    end, 350)

    local recognitionListener = luajava.createProxy("android.speech.RecognitionListener", {
      onReadyForSpeech = function(params)
      end,
      onResults = function(params)
        local results = params.getStringArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
        local text = results.get(0)

        handler.postDelayed(function()
          vibrator.vibrate(100)
        end, 350)

        if text and text ~= "" then
          if text:lower() == "توقف" then
            if recognizer then
              recognizer.stopListening()
              recognizer.destroy()
              recognizer = nil
            end
            this.speak("تم إيقاف الإملاء الصوتي.")
            listening = false
            return
          end

          local language = "english"
          local defaultLanguage = Locale.getDefault().getLanguage()
          local languageCodes = { ["english"] = "en" }

          local languageCode = languageCodes[language]
          if languageCode then
            local wordsToTranslate = text
            local translatedWords = ""

            local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
            url = url .. "&tl=" .. languageCode

            Http.get(url, function(status, result)
              if status == 200 then
                translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                translatedWords = Html.fromHtml(translatedWords).toString()
                service.paste(translatedWords .. ". ")
                this.speak(translatedWords)

                handler.postDelayed(function()
                  if listening then
                    startVoiceRecognition(activity)
                  end
                end, 1500)
              end
            end)
          end
        else
          this.speak("لم يتم التقاط أي نص.")
        end
      end,
      onError = function(error)
      end
    })

    recognizer.setRecognitionListener(recognitionListener)
    recognizer.startListening(intent)
  end

  startVoiceRecognition(activity)
end

trans()
